/**
 * CV.java
 *
 * File generated from the medication::CV uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class CV.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CV", propOrder = {
	"originalText1"
})
@XmlRootElement(name = "CV")
public class CV extends net.ihe.gazelle.medication.CE implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          The text or phrase used as
	                                the basis for the coding.                      .
	 */
	@XmlElement(name = "originalText", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.ED originalText1;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return originalText1.
	 * @return originalText1 :                          The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                      
	 */
	public net.ihe.gazelle.medication.ED getOriginalText1() {
	    return originalText1;
	}
	
	/**
	 * Set a value to attribute originalText1.
	 * @param originalText1 :                          The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                      .
	 */
	public void setOriginalText1(net.ihe.gazelle.medication.ED originalText1) {
	    this.originalText1 = originalText1;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "CV").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(CV cV, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cV != null){
   			net.ihe.gazelle.medication.CE.validateByModule(cV, location, cvm, diagnostic);
			net.ihe.gazelle.medication.ED.validateByModule(cV.getOriginalText1(), location + "/originalText", cvm, diagnostic);
    	}
    }

}